summaryrefslogtreecommitdiff
path: root/t/tap-basic.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-06-24 10:36:15 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-06-25 10:29:43 +0200
commitc2a52bf0e8e87b8f347ca22b9ab2da7613bc4336 (patch)
tree1e2115c0d24da906daa64cc84d853e538129574f /t/tap-basic.sh
parentaa630a928a586fd8dc8a087337c3462d7f4fd1c6 (diff)
downloadautomake-c2a52bf0e8e87b8f347ca22b9ab2da7613bc4336.tar.gz
tests: simpler workaround for shells losing the exit status in exit trap
Now that we can assume our tests are run by a decent POSIX shell, we can simplify our workaround aimed at having the exit status propagated correctly to the code in the exit trap. Unfortunately, we cannot dispense with such a workaround altogether, because it's still required by some shells we need to support (at least Solaris 10 /bin/ksh and /usr/xpg4/bin/sh). For more information about the need of that workaround, see the entry about 'trap' in the section "Limitations of Shell Builtins" in the Autoconf manual: <http://www.gnu.org/software/autoconf/manual/autoconf.html#trap> The new workaround has been tested successfully with the following shells: - Bash 4.1 - Bash 3.2 - Bash 3.0 - Bash 2.05b - dash 0.5.5.1 - dash 0.5.2 - AT&T Ksh 93u (from official Debian package) - MirBSD Korn Shell 40.2 (from official Debian package) - Solaris 9, 10 and 11 /bin/ksh - Solaris 9, 10 and 11 /usr/xpg4/bin/sh - NetBSD 5.1 /bin/sh - NetBSD 5.1 /bin/ksh * t/ax/test-init.sh (Exit): Rename ... (_am_exit): ... like this. (exit): New alias for '_am_exit'. We cannot simply redefine 'exit' as a shell function, because some shells (dash 0.5.5.1, Solaris 10 /bin/ksh and /usr/xpg4/bin/sh) do not allow it. (_am_exit, trap): Add extra escaping for 'exit' calls, to ensure we really invoke the 'exit' builtin and not our alias with the same name. * configure.ac: Check that the shell selected to run our testsuite supports aliases named like shell builtins. * t/REAMDE: Adjust. * All tests: Adjust, by simply using 'exit' instead of 'Exit'. * t/self-check-explicit-skips.sh: Adjust: the first usage of 'exit' after it has been redefined as an alias must be on a new line w.r.t. that where the alias is defined, in order for the redefinition to be honored. * syntax-checks.mk (sc_tests_Exit_not_exit): Delete. (sc_tests_exit_not_Exit): New. (syntax_check_rules): Adjust. (sc_tests_automake_fails): Simplify the recipe a little. * Several tests: Remove now useless spurious quoting once required to placate the 'sc_tests_Exit_not_exit' maintainer check. * gen-testsuite-part: Likewise. Also, avoid uses of 'Exit' in the generated scripts. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/tap-basic.sh')
-rwxr-xr-xt/tap-basic.sh14
1 files changed, 7 insertions, 7 deletions
diff --git a/t/tap-basic.sh b/t/tap-basic.sh
index 2e12e6ec0..b3b79de89 100755
--- a/t/tap-basic.sh
+++ b/t/tap-basic.sh
@@ -24,7 +24,7 @@
# Note that some of the features checked here are checked in other
# test cases too, usually in a more thorough and detailed way.
-. ./defs || Exit 1
+. ./defs || exit 1
fetch_tap_driver
@@ -80,7 +80,7 @@ $AUTOMAKE
# Basilar usage and testsuite progress output.
-$MAKE check >stdout && { cat stdout; Exit 1; }
+$MAKE check >stdout && { cat stdout; exit 1; }
cat stdout
count_test_results total=20 pass=4 fail=4 xpass=4 xfail=4 skip=4 error=0
@@ -127,7 +127,7 @@ Bail out!
ok 1
END
-TESTS=bail.test $MAKE -e check >stdout && { cat stdout; Exit 1; }
+TESTS=bail.test $MAKE -e check >stdout && { cat stdout; exit 1; }
cat stdout
count_test_results total=1 pass=0 fail=0 xpass=0 xfail=0 skip=0 error=1
@@ -137,16 +137,16 @@ test -f bail.log
test -f test-suite.log
grep '^ERROR: bail\.test - Bail out!' stdout
-grep '^PASS:' stdout && Exit 1
+grep '^PASS:' stdout && exit 1
test $($FGREP -c ': bail.test' stdout) -eq 1
-$FGREP 'success.test' stdout && Exit 1
+$FGREP 'success.test' stdout && exit 1
# Override TEST_LOGS from the command line, making it point to a test
# (ok.test) that has to be generated at make time.
rm -f *.log *.test
-TEST_LOGS=ok.log $MAKE -e check >stdout || { cat stdout; Exit 1; }
+TEST_LOGS=ok.log $MAKE -e check >stdout || { cat stdout; exit 1; }
cat stdout
count_test_results total=3 pass=1 fail=0 xpass=0 xfail=1 skip=1 error=0
@@ -157,7 +157,7 @@ test ! -f success.log
test ! -f bail.log
test -f test-suite.log
-$EGREP '(bail|success)\.test' stdout && Exit 1
+$EGREP '(bail|success)\.test' stdout && exit 1
cat > exp << 'END'
PASS: ok.test 1